/*
STM32L476 + Companion Board
7-segment multiplexed display, DMA referesh
gbm, 01'2017
*/

#include "board.h"
#include "7seg-common.h"

static const uint32_t displayoff = DigAct(0) | SegAct(0);
//========================================================================
int main(void)
{
	// enable peripherals
	RCC->AHB1ENR |= RCC_AHB1ENR_DMA1EN;
	// setup clock & GPIOC
	common_setup();
	// LED multiplexing DMA
	DMA1_CSELR->CSELR = BF4(0, LEDMpx_DMARq) | BF4(3, LEDMpx_DMARq) | BF4(6, LEDMpx_DMARq);
	LEDMpx_DMACh->CPAR = (uint32_t)&LEDMpx_PORT->BSRR;
	LEDMpx_DMACh->CMAR = (uint32_t)display;
	LEDMpx_DMACh->CNDTR = NDIGITS;
	LEDMpx_DMACh->CCR = DMA_CCR_DIR_M2P | DMA_CCR_MSIZE32 | DMA_CCR_PSIZE32
		| DMA_CCR_MINC | DMA_CCR_CIRC | DMA_CCR_EN;
	LEDMpxOff_DMACh->CPAR = (uint32_t)&LEDMpx_PORT->BSRR;
	LEDMpxOff_DMACh->CMAR = (uint32_t)&displayoff;
	LEDMpxOff_DMACh->CNDTR = 1;
	LEDMpxOff_DMACh->CCR = DMA_CCR_DIR_M2P | DMA_CCR_MSIZE32 | DMA_CCR_PSIZE32
		| DMA_CCR_MINC | DMA_CCR_CIRC | DMA_CCR_EN;
	// LED multiplexing timer
	LEDMpx_TIM->PSC = SYSCLK_FREQ / MPX_FREQ / MPX_STEPS - 1;
	LEDMpx_TIM->ARR = MPX_STEPS - 1;
	LEDMpx_TIM->DIER = TIM_DIER_CC1DE | TIM_DIER_UDE;
	LEDMpx_TIM->CR1 = TIM_CR1_CEN;
	
	SysTick_Config(SYSCLK_FREQ / SYSTICK_FREQ);
	SCB->SCR = SCB_SCR_SLEEPONEXIT_Msk;	// sleep while not in handler
	__WFI();	// go to sleep
}

void SysTick_Handler(void)
{
	run_every_10ms();
}
