/*
	Nucleo64 + N64c1a board defs
	gbm 12'2016
*/
#ifndef STM32N64COMP1_H_
#define STM32N64COMP1_H_
#include "stm32l4yy.h"
// Nucleo64 blue button
#define BTN_PORT	GPIOC
#define BTN_BIT		13
#define BTN_DOWN	((~BTN_PORT->IDR >> BTN_BIT & 1))
//========================================================================
// 4-digit, 7-segment display on PC0..11
#define LEDMpx_PORT	GPIOC

#define SEG_A_MSK (1u << 6)
#define SEG_B_MSK (1u << 4)
#define SEG_C_MSK (1u << 3)
#define SEG_D_MSK (1u << 1)
#define SEG_E_MSK (1u << 2)
#define SEG_F_MSK (1u << 5)
#define SEG_G_MSK (1u << 0)
#define SEG_DP_MSK (1u << 7)
#define SEG_MSK 0xffu

#define DIG0_MSK (1u << 8)
#define DIG1_MSK (1u << 9)
#define DIG2_MSK (1u << 10)
#define DIG3_MSK (1u << 11)
#define DIG_MSK (0xfu << 8)

#define COMMON_CATHODE
#ifdef COMMON_CATHODE	// CC, no amplifiers
#define SegActLevel	1
#define DigActLevel	0
#else	// CA, no amplifiers
#define SegActLevel	0
#define DigActLevel	1
#endif

// BSRR mask shift values
#define LEDMpx_SegOnShift	((!SegActLevel) * 16)
#define LEDMpx_SegOffShift	(SegActLevel * 16)
#define LEDMpx_DigOnShift	((!DigActLevel) * 16)
#define LEDMpx_DigOffShift	(DigActLevel * 16)
// BSRR value generation
#define DigAct(x)	((x) << LEDMpx_DigOnShift | (DIG_MSK ^ (x)) << LEDMpx_DigOffShift)
//static inline uint32_t DigAct(uint16_t x) {return ((x) << LEDMpx_DigOnShift | (DIG_MSK ^ (x)) << LEDMpx_DigOffShift);}
#define SegAct(x)	((x) << LEDMpx_SegOnShift | (SEG_MSK ^ (x)) << LEDMpx_SegOffShift)
//static inline uint32_t SegAct(uint16_t x) {return ((x) << LEDMpx_SegOnShift | (SEG_MSK ^ (x)) << LEDMpx_SegOffShift);}
//========================================================================
// Peripherals
#define LEDMpx_TIM	TIM4
#define LEDMpx_IRQn	TIM4_IRQn
#define LEDMpx_IRQHandler	TIM4_IRQHandler
#define LEDMpx_DMACh	DMA1_Channel7
#define LEDMpx_DMARq	6
#define LEDMpxOff_DMACh	DMA1_Channel1
#define LEDMpxFad_DMACh	DMA1_Channel4

#endif
