/*
	STM32L4 series enhanced defs
	gbm 03'2016

	Should be included instead of original stm32f4xx.h.
*/

#ifndef __STM32L4YY_H
#define __STM32L4YY_H

#include "stm32l4xx.h"
#include "stm32yyyy.h"	// add defs common to STM32 family
#include "stm32util.h"

// STM32F4x register/bit defs not present in stm32f4xx.h file

#define FLASH_CR_PNBV(v)	(((v) & 0xff) << 3)
//#define FLASH_CR_PSIZEV(v)	(((v) & 3) << 8)
//#define FLASH_CR_PSIZE32	(2 << 8)

#define RCC_CFGR_PLLMULV(a)	(((a - 2) & 0xf) << 18)

#define  RCC_PLLCFGR_PLLMV(v)	(((v - 1) & 7) << 4)	// 2..63
#define  RCC_PLLCFGR_PLLNV(v)	((v & 0x7f) << 8)	// must be in range 50..432                     ((uint32_t)0x00007FC0)
#define  RCC_PLLCFGR_PLLRV(v)	((((v >> 1) - 1) & 3) << 25)	// 2, 4, 6, 8
#define  RCC_PLLCFGR_PLLQV(v)	((((v >> 1) - 1) & 3) << 21)	// 2, 4, 6, 8

#define GPIOA_MODER_DEFAULT	0x0c000000	// ?
#define GPIOA_OSPEEDR_DEFAULT	0x0c000000
#define GPIOB_MODER_DEFAULT	0x0280
#define GPIOB_OSPEEDR_DEFAULT	0xc0
#define GPIOA_PUPDR_DEFAULT	0x64000000
//#define GPIOA_PUPDR_SWD	0x24000000

//#define BRR(p)	(((uint16_t *)&(p->BSRR))[1])	// Bit Reset Register - upper halfword of BSRR

#define  PWR_CR2_PLSV(a)	(((a) & 7) << 1)     /*!< Bit 0 */

#define	PR	PR1	// EXTI
#define	EXTI_RTSR_TR16	EXTI_RTSR1_RT16

#define DMA_CCR_MSIZE16	DMA_CCR_MSIZE_0
#define DMA_CCR_MSIZE32	DMA_CCR_MSIZE_1
#define DMA_CCR_PSIZE16	DMA_CCR_PSIZE_0
#define DMA_CCR_PSIZE32	DMA_CCR_PSIZE_1
#define DMA_CCR_DIR_P2M	0
#define DMA_CCR_DIR_M2P	DMA_CCR_DIR

//#define VREFINT_mV	1210

// Calibration values stored in ROM
#define VREFINT_CAL_mV	3000
#define VREFINT_CAL	(*(uint16_t *)0x1fff75aa)	// @ 3.3V
#define TS_CAL1	(*(uint16_t *)0x1fff75a8)
#define TS_CAL2	(*(uint16_t *)0x1fff75ca)

#define T_CAL1	30
#define T_CAL2	110

#define ADCH_VREF	0
#define	ADCH_TSEN	17

#define	ADC_SMPR_480	7


#endif
